using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;

using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Syncfusion.Runtime.Serialization;

namespace _6114_Sample
{
    public partial class Form1 : Form
    {
        private TabbedMDIManager tabbedMdiManager;
        int count = 0;
        private ArrayList RuntimeDockingWindows;
        private int flag = 0;

        public Form1()
        {
            InitializeComponent();
            this.RuntimeDockingWindows = new ArrayList();

            this.tabbedMdiManager = new TabbedMDIManager();

            this.tabbedMdiManager.AttachToMdiContainer(this);
        }
        

        private void barItem1_Click(object sender, EventArgs e)
        {
            Form2 child = new Form2();
            child.Text = "MDI Child" + (count).ToString();
            child.Name = "MDI Child" + (count).ToString();
            child.MdiParent = this;
            child.Show();
            count++;
            //this.RuntimeDockingWindows.Add(child.Name.ToString());
        }

        
        private void Loadtabstate()
        {

            ArrayList temp = new ArrayList();
            string str = "";

            AppStateSerializer aser = new AppStateSerializer(SerializeMode.XMLFile, "..\\..\\stateinfo");

            temp = (ArrayList)aser.DeserializeObject("RuntimeControls");
            foreach (string s in temp)
            {
                str += s + "\n";
                
            }


            Form2[] f = new Form2[temp.Count];

            for (int i = 0; i < temp.Count; i++)
            {
                f[i] = new Form2();
                str = (string)temp[i];
                f[i].Name = str;
                f[i].Text  = str;

               
                f[i].MdiParent = this;
                f[i].Show();
                
            }
            

        }
        private void SavetabState()
        {
            AppStateSerializer aser = new AppStateSerializer(SerializeMode.XMLFile, "..\\..\\stateinfo");

            aser.SerializeObject("RuntimeControls", this.RuntimeDockingWindows);
            this.tabbedMdiManager.SaveTabGroupStates(aser);
            aser.PersistNow();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            this.RuntimeDockingWindows.Clear();
            Form[] child = this.tabbedMdiManager.MdiChildren;
            for (int i = 0; i < child.Length; i++) 
            {
                this.RuntimeDockingWindows.Add(child[i].Name.ToString());
            }
            SavetabState();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            
            if (flag == 0)
            {
                flag = 1;
                ArrayList temp = new ArrayList();
                AppStateSerializer aser = new AppStateSerializer(SerializeMode.XMLFile, "..\\..\\stateinfo");
                temp = (ArrayList)aser.DeserializeObject("RuntimeControls");
                
                if (temp != null)
                {
                    for (int i = 0; i < temp.Count; i++)
                        this.RuntimeDockingWindows.Add(temp[i]);
                    count = temp.Count;
                    this.Loadtabstate();
                   
                }
                this.tabbedMdiManager.LoadTabGroupStates(aser);
              
            }
        }
    }
}
           
        
